=== modified file 'src/com/goldencode/p2j/persist/serial/XmlExport.java'
--- src/com/goldencode/p2j/persist/serial/XmlExport.java	2022-10-14 12:38:17 +0000
+++ src/com/goldencode/p2j/persist/serial/XmlExport.java	2022-11-11 18:30:41 +0000
@@ -1391,52 +1646,61 @@
    {
       String legacyName = schema.getName();
       boolean isDataset = (ds != null);
+      Iterable<TempTableSchema.Column> elements = schema.elementColumns();
+      Iterable<TempTableSchema.Column> attributes = schema.attributeColumns();
+      boolean hasAttrs = attributes.iterator().hasNext();
+      SortedSet<Integer> fields = new TreeSet<>();
+      if (hasAttrs)
+      {
+         for (TempTableSchema.Column column : schema.columns())
+         {
+            if (column.getNodeType() != XmlNodeType.HIDDEN)
+            {
+               fields.add(column.getOrder());
+            }
+         }
+      }
       
-      indent();
-      writer.writeStartElement("xsd:element");
-      writer.writeAttribute("name", tableName);
-      writer.writeAttribute("minOccurs", "0");
-      writer.writeAttribute("maxOccurs", "unbounded");
-      if (isDataset && !legacyName.equals(tableName))
-      {
-         writer.writeAttribute("prodata:tableName", legacyName);
-      }
-      if (inDataset && !minSchema && !schema.isNoUndo())
-      {
-         writer.writeAttribute("prodata:undo", "true");
-         if (buffer.isAfterBuffer())
-         {
-            // using [buffer.beforeBuffer().unwrap().name()] will raise a [DeferredLegacyErrorException]
-            String beforeName = ((BufferImpl) buffer.beforeBuffer().getResource()).doGetName();
-            writer.writeAttribute("prodata:beforeTable", beforeName);
-         }
-      }
-      lineBreak();
-      ++indentLevel;
+      if (!external)
       {
          indent();
-         writer.writeStartElement("xsd:complexType");
+         writer.writeStartElement("xsd:element");
+         writer.writeAttribute("name", tableName);
+         writer.writeAttribute("minOccurs", "0");
+         writer.writeAttribute("maxOccurs", "unbounded");
+         if (isDataset && !legacyName.equals(tableName))
+         {
+            writer.writeAttribute("prodata:tableName", legacyName);
+         }
+         if (inDataset && !minSchema && !schema.isNoUndo())
+         {
+            writer.writeAttribute("prodata:undo", "true");
+            if (buffer.isAfterBuffer())
+            {
+               // using [buffer.beforeBuffer().unwrap().name()] will raise a [DeferredLegacyErrorException]
+               String beforeName = ((BufferImpl) buffer.beforeBuffer().getResource()).doGetName();
+               writer.writeAttribute("prodata:beforeTable", beforeName);
+            }
+         }
          lineBreak();
          ++indentLevel;
-         Iterable<TempTableSchema.Column> elements = schema.elementColumns();
-         Iterable<TempTableSchema.Column> attributes = schema.attributeColumns();
-         boolean hasAttrs = attributes.iterator().hasNext();
-         SortedSet<Integer> fields = new TreeSet<>();
-         if (hasAttrs)
-         {
-            for (TempTableSchema.Column column : schema.columns())
-            {
-               if (column.getNodeType() != XmlNodeType.HIDDEN)
-               {
-                  fields.add(column.getOrder());
-               }
-            }
-         }
+      }
+      {
+         if (!external)
          {
             indent();
-            writer.writeStartElement("xsd:sequence");
+            writer.writeStartElement("xsd:complexType");
             lineBreak();
             ++indentLevel;
+         }
+         {
+            if (!external)
+            {
+               indent();
+               writer.writeStartElement("xsd:sequence");
+               lineBreak();
+               ++indentLevel;
+            }
             {
                for (TempTableSchema.Column column : elements)
                {
@@ -1537,18 +1801,23 @@
             }
             lineBreak();
          }
-
+         if (!external)
+         {
+            --indentLevel;
+            indent();
+            writer.writeEndElement(); // xsd:complexType
+            lineBreak();
+         }
+      }
+      
+      if (!external)
+      {
          --indentLevel;
          indent();
-         writer.writeEndElement(); // xsd:complexType
+         writer.writeEndElement(); // xsd:element
          lineBreak();
       }
       
-      --indentLevel;
-      indent();
-      writer.writeEndElement(); // xsd:element
-      lineBreak();
-      
       int keyPrefix = (this.ds == null) ? 0 : ds.getIndexOf(buffer);
       int i = 0;
       // save now the index list to be processed later 
@@ -1583,7 +1852,6 @@
     * @param   isDataset
     *          If {@code true}, this is part of a dataset SCHEMA and additional attributes will
     *          be written.
-    *
     * @return  {@code true} on success. Otherwise the error is already dispatched to 
     *          {@code ErrorManager} before returning.
     *          
@@ -1634,7 +1902,7 @@
       {
          writer.writeAttribute("nillable", String.valueOf(column.isNillable()));
       }
-      if (addType != null)
+      if (addType != null && defaultValues)
       {
          writer.writeAttribute("prodata:dataType", addType);
       }
@@ -1643,42 +1911,68 @@
       {
          if (extent != null && extent > 0)
          {
-            writer.writeAttribute("minOccurs", String.valueOf(extent));
+            writer.writeAttribute("minOccurs", defaultValues ? String.valueOf(extent) : "0");
             writer.writeAttribute("maxOccurs", String.valueOf(extent));
          }
+         else if (!defaultValues && !isAttr)
+         {
+            writer.writeAttribute("minOccurs", "0");
+         }
       }
       else
       {
-         if (!defaultValues)
+         if (extent != null && extent > 0)
+         {
+            writer.writeAttribute("minOccurs", defaultValues ? String.valueOf(extent) : "0");
+            writer.writeAttribute("maxOccurs", String.valueOf(extent));
+         }
+         else if (!defaultValues && !isAttr)
          {
             writer.writeAttribute("minOccurs", "0");
          }
-         else if (extent != null && extent > 0)
-         {
-            writer.writeAttribute("minOccurs", String.valueOf(extent));
-            writer.writeAttribute("maxOccurs", String.valueOf(extent));
-         }
-
-      }
-      if (isDataset)
-      {
-         if (defaultValues)
-         {
+
+      }
+      if (addType != null && !defaultValues)
+      {
+         writer.writeAttribute("prodata:dataType", addType);
+      }
+
+      if (isDataset && defaultValues)
+      {
+//         if (!defaultValues)
+//         {
             String initial = column.getInitial();
             String defVal = Util.defaultValuesMap.get(columnType);
+            if (initial == null && !minSchema)
+            {
+               initial = defVal;
+            }
             if (initial != null && !initial.equals(defVal))
             { 
-               writer.writeAttribute("prodata:initial",
-                                     initial.equals("?") ? "prodata:unknown" : initial);
+               if (type.startsWith("xsd:date") && 
+                        ("today".equalsIgnoreCase(initial) || "now".equalsIgnoreCase(initial)))
+               {
+                  writer.writeAttribute("prodata:initial", "prodata:" + initial.toLowerCase());
+               }
+               else if (initial.equals("?") || 
+                        (column.getType().equals(raw.class) && "".equals(initial)))
+               {
+                  writer.writeAttribute("prodata:initial", "prodata:unknown");
+               }
+               else
+               {
+                  writer.writeAttribute("default", initial);
+               }
             }
-         }
+//         }
       }
       else
       {
          String initial = column.getInitial();
          if (initial != null)
          {
-            boolean initialNull = "?".equals(initial);
+            boolean initialNull = "?".equals(initial) || 
+                     (column.getType().equals(raw.class) && "".equals(initial));
             if (!defaultValues || !initial.equals(Util.defaultValuesMap.get(columnType)))
             {
                if (!initialNull && type.contains("decimal") && !initial.contains("."))
@@ -1693,7 +1987,8 @@
                }
                else
                {
-                  writer.writeAttribute("default", initialNull ? "prodata:unknown" : initial);
+                  writer.writeAttribute(initialNull ? "prodata:initial" : "default", 
+                                        initialNull ? "prodata:unknown" : initial);
                }
             }
          }
@@ -1720,13 +2015,13 @@
       {
          writer.writeAttribute("prodata:fieldName", fieldName);
       }
-      if (hasAttributes)
+      if (!minSchema && hasAttributes)
       {
          int userOrder = fields.headSet(column.getOrder()).size() + 1;
          writer.writeAttribute("prodata:userOrder", String.valueOf(userOrder));
       }
 
-      if ("prodata:clob".equals(addType))
+      if (!minSchema && "prodata:clob".equals(addType))
       {
          String cp = column.getCodePage();
          if (!StringUtils.isEmpty(cp))
@@ -1736,16 +2031,17 @@
       }
 
 
-//      if (!isSchemaOnly)
-//      {
+      if (!minSchema )
+      {
          String fmt = column.getDefinedFormat();
          
          BaseDataType defValue = BaseDataType.generateDefault(columnType);
-         if (!StringUtils.isEmpty(fmt) && !fmt.equalsIgnoreCase(defValue.defaultFormatString()))
+         if (!StringUtils.isEmpty(fmt) && (
+                  /* defaultValues || */ !fmt.equalsIgnoreCase(defValue.defaultFormatString())))
          {
             writer.writeAttribute("prodata:format", fmt);
          }
-//      }
+      }
       
       
       if (!minSchema)
@@ -1909,10 +2205,10 @@
          
          indent();
          boolean hasTextNodes = schema.textColumns().iterator().hasNext();
-         writer.writeStartElement(rowName);
+         writer.writeStartElement((ttNsPrefix == null || rowName.contains(":") ? "" : ttNsPrefix + ":") + rowName);
          if (xmlns != null && !xmlns.isEmpty())
          {
-            writer.writeAttribute("xmlns", xmlns);
+            writer.writeAttribute("xmlns" + (ttNsPrefix == null ? "" : ":" + ttNsPrefix) , xmlns);
          }
          
          // NOTE: the next conditional is half commented out because, in some cases which we were not able to
@@ -2342,8 +2638,11 @@
        * 
        * @return  {@code true} on success. Otherwise the errors encountered were already notified
        *          to {@code ErrorManager}.
+       * @throws XMLStreamException 
+       *         on unexpected processing error.
+       * @throws IOException
+       *         on I/O error 
        *
-       * @see     java.lang.Thread#run()
        */
       public abstract boolean run()
       throws XMLStreamException, IOException;

=== modified file 'src/com/goldencode/p2j/persist/serial/XmlImport.java'
--- src/com/goldencode/p2j/persist/serial/XmlImport.java	2022-10-14 12:38:17 +0000
+++ src/com/goldencode/p2j/persist/serial/XmlImport.java	2022-10-18 08:45:19 +0000
@@ -42,6 +42,7 @@
 **     OM  20220914 Use MAX-WIDTH to generate custom sized varchar columns.
 **     IAS 20220926 Fixed READ-XMLSCHEMA support.
 **     IAS 20221014 More fixes to READ-XMLSCHEMA support.
+**     IAS 20221018 Fixed processing of 'now' and 'today' INITIAL attribute value.
 */
 
 /*
@@ -1866,19 +1867,30 @@
                               // Unable to set initial value '<value>' from XML Schema for field '<field>'.
                               return false;
                            }
-                           
-                           try
-                           {
-                              Constructor<? extends BaseDataType> ctor = 
-                                 (Constructor<? extends BaseDataType>) fwdType.getConstructor(String.class);
-                              defVal = ctor.newInstance(defaultStrVal);
-                           }
-                           catch (NoSuchMethodException | IllegalAccessException | 
-                                  InstantiationException | InvocationTargetException e)
-                           {
-                              ErrorManager.recordOrShowError(13143, defaultStrVal, fieldName);
-                              // Unable to set initial value '<value>' from XML Schema for field '<field>'.
-                              return false;
+                           if (fwdType == date.class && "today".equalsIgnoreCase(defaultStrVal))
+                           {
+                                defVal = new character("today"); 
+                           }
+                           else if ((fwdType == datetime.class || fwdType == datetimetz.class) &&
+                                     "now".equalsIgnoreCase(defaultStrVal))
+                           {
+                              defVal = new character("now"); 
+                           }
+                           else
+                           {
+                              try
+                              {
+                                 Constructor<? extends BaseDataType> ctor = 
+                                    (Constructor<? extends BaseDataType>) fwdType.getConstructor(String.class);
+                                 defVal = ctor.newInstance(defaultStrVal);
+                              }
+                              catch (NoSuchMethodException | IllegalAccessException | 
+                                     InstantiationException | InvocationTargetException e)
+                              {
+                                 ErrorManager.recordOrShowError(13143, defaultStrVal, fieldName);
+                                 // Unable to set initial value '<value>' from XML Schema for field '<field>'.
+                                 return false;
+                              }
                            }
                         }
                         

=== modified file 'src/com/goldencode/p2j/util/AppServerHelper.java'
--- src/com/goldencode/p2j/util/AppServerHelper.java	2022-09-12 07:16:17 +0000
+++ src/com/goldencode/p2j/util/AppServerHelper.java	2022-11-02 07:58:35 +0000
@@ -77,6 +77,7 @@
 **     CA  20220428 Fixed memptr, extent, table arguments when the request is remote.
 **     CA  20220602 Added basic support for transport of object instances over appserver call.
 **     CA  20220912 If a dataset from the call has no buffers added to it, set it to unknown.
+**     IAS 20221029 Fixed TableParameter processing.
 */
 
 /*
@@ -2660,20 +2661,18 @@
 
                   boolean input = (mode == 'I' || mode == 'U');
                   boolean output = (mode == 'O' || mode == 'U');
+                  
+                  int schemaMarshalLevel = tableParam.getSchemaMarshalLevel();
 
-//               try
-//               {
                   arg = new TableWrapper(new TempTableResultSet(tempDMO, input, output, append, input));
                   String tableName = ((BufferImpl) tempDMO).buffer().getDmoInfo().legacyTable;
                   ((TableWrapper) arg).setTableName(tableName);
-//               }
-//               catch (ClassNotFoundException e)
-//               {
-//                  String err = String.format("Could not process temp DMO %s as a parameter!", 
-//                                              tempDMO.getClass().getName());
-//                  
-//                  throw new IllegalArgumentException(err, e);
-//               }
+                  ((TableWrapper) arg).setSchemaMarshalLevel(schemaMarshalLevel);
+                  handle tableHandle = ((Buffer) tempDMO).tableHandle();
+                  if (tableHandle._isValid())
+                  {
+                     ((TableWrapper) arg).init((TempTable) tableHandle.getResource());
+                  }
 
                   try
                   {

=== modified file 'src/com/goldencode/p2j/util/ErrorManager.java'
--- src/com/goldencode/p2j/util/ErrorManager.java	2022-10-06 17:56:26 +0000
+++ src/com/goldencode/p2j/util/ErrorManager.java	2022-11-08 15:02:19 +0000
@@ -247,6 +247,8 @@
 **                           with namesakes in DMO. See #6694.
 **     IAS 20221003          Fixed error message for error 3131
 **     IAS 20221006          Reverted error message for error 3131 change.
+**     IAS 20221102          Added message for error 12323.
+**     IAS 20221100          Added message for warning 13095.
 */
 
 /*
@@ -3083,7 +3085,7 @@
          case 12301: msg = "Source and target are the same table in temp-table copy operation for %1"; break;     // dataset-copy (itself)
          case 12303: msg = "COPY-TEMP-TABLE requires %1 and %2 columns to match exactly unless the fourth loose-mode parameter is passed as TRUE"; break; // dataset-copy (table structure not matching)
          case 12310: msg = "Caller and called dataset parameters have different number of members"; break;
-         
+         case 12323: msg = "A NO-SCHEMA-MARSHAL table cannot be used as a parameter where the receiving side does not have a pre-prepared schema"; break;
          case 12344: msg = "Cannot turn on TRACKING-CHANGES for a static temp-table unless DEFINED with a BEFORE-TABLE phrase"; break;
          case 12352: msg = "Argument %1 to query callback method must be a valid query event name such as OFF-END"; break;
          case 12355: msg = "TRACKING-CHANGES may not be turned on for a non-dataset temp-table"; break;
@@ -3146,6 +3148,7 @@
          case 13090: msg = "XML Schema definition for field '%1' in table '%2' not found"; break;
          case 13091: msg = "XML Schema definition for table '%1' contains extra field '%2'"; break;
          case 13093: msg = "Write temp-table data failed for WRITE-XML"; break;
+         case 13095: msg = "WRITE-XML target-type must be 'FILE' when buffers of a dataset have a different NAMESPACE-URI"; break;
          case 13097: msg = "Write schema failed for WRITE-XMLSCHEMA"; break;
          case 13138: msg = "Temp-table '%1' not found in XML Schema"; break;
 case 13139: msg = "Field '%1' already added from XML Schema"; break;

=== modified file 'src/com/goldencode/p2j/util/TableParameter.java'
--- src/com/goldencode/p2j/util/TableParameter.java	2022-10-06 11:27:04 +0000
+++ src/com/goldencode/p2j/util/TableParameter.java	2022-11-11 09:23:16 +0000
@@ -38,6 +38,9 @@
 **                  INPUT-OUTPUT mode, and the DATASET-HANDLE, DATASET, TABLE-HANDLE or TABLE versions.
 **     CA  20220727 Fixed OO dataset/table parameters (at the method definition and method call) when there is
 **                  an APPEND option.
+**     IAS 20221029 Added SCHEMA-MARSHAL attribute support.
+**     IAS 20221108 Replaced static 'TempTableBuilder.createRemoteTable' with a regular one.
+**     IAS 20221111 Fixed 'schemaMarshalLevel' support.
 */
 
 /*
@@ -134,6 +137,9 @@
    /** {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT. */
    private boolean output = false;
    
+   /** Table SCHEMA-MARSHAL attribute value encodes as int */ 
+   private int schemaMarshalLevel;
+   
    /** Flag indicating this is a TABLE-HANDLE argument. */
    private boolean isTableHandle = false;
    
@@ -218,6 +224,8 @@
       this.options     = options;
       this.input       = input;
       this.output      = output;
+      this.schemaMarshalLevel = ((AbstractTempTable)this.tableHandle.unwrapTempTable()).
+                                       getSchemaMarshalLevel();
    }
    
    /**
@@ -390,11 +398,12 @@
       // if INPUT, create a dynamic table
       if (resultSet.isInput() && !resultSet.isFromJson() && resultSet.isAfterTable())
       {
-         BufferImpl buff = TempTableBuilder.createRemoteTable(resultSet.getTableName(),
+         BufferImpl buff = new TempTableBuilder().createRemoteTable(resultSet.getTableName(),
                                                               resultSet.propertyIterator(),
                                                               resultSet.getIndexes(),
                                                               resultSet.getXmlns(),
-                                                              resultSet.getXmlPrefix());
+                                                              resultSet.getXmlPrefix(),
+                                                              resultSet.getSchemaMarshalLevel());
          
          TemporaryBuffer.insertAllRows(resultSet,
                                        (Temporary) buff,
@@ -596,6 +605,15 @@
       return parameterIndex;
    }
    
+   /** Get encoded table SCHEMA-MARSHAL attribute value.
+    * 
+    * @return encoded table SCHEMA-MARSHAL attribute value.
+    */
+   public int getSchemaMarshalLevel()
+   {
+      return schemaMarshalLevel;
+   }
+
    /**
     * Set 1-based index of the table parameter (in declaration of the function).
     *

